/**
* DO NOT EDIT THIS FILE.
* See the following change record for more information,
* https://www.drupal.org/node/2815083
* @preserve
**/

(function ($, Drupal) {
  Drupal.behaviors.color = {
    attach: function attach(context, settings) {
      var i = void 0;
      var j = void 0;
      var colors = void 0;

      var farbzone = $(context).find('#orejime-settings #color-zone').once('color');
      var form = $(context).find('#orejime-settings .color-form').once('color');
      if (farbzone.length === 0) {
        return;
      }
      var inputs = [];
      var focused = null;

      $('<div class="color-placeholder"></div>').once('color').prependTo(farbzone);
      var farb = $.farbtastic('.color-placeholder');

      var reference = settings.color;
      console.log(reference);
      Object.keys(reference || {}).forEach(function (color) {
        if(color != 'enable' && color !='btn_radius' && color !='url_css')
        reference[color] = farb.RGBToHSL(farb.unpack(reference[color]));
      });
      var height = [];
      var width = [];

      function preview() {
        Drupal.color.callback(context, settings, form, farb, height, width);
      }
      //
      function resetScheme() {
        form.find('#edit-scheme').each(function () {
          this.selectedIndex = this.options.length - 1;
        });
      }

      function shiftColor(given, ref1, ref2) {
        var d = void 0;

        given = farb.RGBToHSL(farb.unpack(given));

        given[0] += ref2[0] - ref1[0];

        if (ref1[1] === 0 || ref2[1] === 0) {
          given[1] = ref2[1];
        } else {
          d = ref1[1] / ref2[1];
          if (d > 1) {
            given[1] /= d;
          } else {
            given[1] = 1 - (1 - given[1]) * d;
          }
        }

        if (ref1[2] === 0 || ref2[2] === 0) {
          given[2] = ref2[2];
        } else {
          d = ref1[2] / ref2[2];
          if (d > 1) {
            given[2] /= d;
          } else {
            given[2] = 1 - (1 - given[2]) * d;
          }
        }

        return farb.pack(farb.HSLToRGB(given));
      }

      function callback(input, color, propagate, colorScheme) {
        var matched = void 0;

        $(input).css({
          backgroundColor: color,
          color: farb.RGBToHSL(farb.unpack(color))[2] > 0.5 ? '#000' : '#fff'
        });

        if ($(input).val() && $(input).val() !== color) {
          $(input).val(color);

          if (propagate) {
            i = input.i;
            for (j = i + 1;; ++j) {
              if (!locks[j - 1] || $(locks[j - 1]).is('.is-unlocked')) {
                break;
              }
              matched = shiftColor(color, reference[input.key], reference[inputs[j].key]);
              callback(inputs[j], matched, false);
            }
            for (j = i - 1;; --j) {
              if (!locks[j] || $(locks[j]).is('.is-unlocked')) {
                break;
              }
              matched = shiftColor(color, reference[input.key], reference[inputs[j].key]);
              callback(inputs[j], matched, false);
            }

            preview();
          }

          if (!colorScheme) {
            resetScheme();
          }
        }
      }

      function focus(e) {
        var input = e.target;

        if (focused) {
          $(focused).off('keyup', farb.updateValue).off('keyup', preview).off('keyup', resetScheme).parent().removeClass('item-selected');
        }
        focused = input;
        farb.linkTo(function (color) {
          callback(input, color, true, false);
        });
        farb.setColor(input.value);
        $(focused).on('keyup', farb.updateValue).on('keyup', preview).on('keyup', resetScheme).parent().addClass('item-selected');
      }
      //
      form.find('.js-color-palette').each(function () {
        this.key = this.id.substring(13);
        console.log(this.key);
        farb.linkTo(function () {}).setColor('#000').linkTo(this);

      }).on('focus', focus);

      form.find('.js-color-palette label');

      inputs[0].focus();

      preview();
    }
  };
})(jQuery, Drupal);
